﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace SchoolProject
{
    /// <summary>
    /// Логика взаимодействия для WorkOfEmployeePage.xaml
    /// </summary>
    public partial class WorkOfEmployeePage : Page
    {
        public WorkOfEmployeePage()
        {
            InitializeComponent();
            DataContext = new Employee();
            Load();
        }

        public void Load()
        {
            CmbPosition.ItemsSource = DB.db.Position.ToList();
            CmbSubdivision.ItemsSource = DB.db.Subdivision.ToList();
        }


        public WorkOfEmployeePage(int IDEmployee)
        {
            InitializeComponent();
            DataContext = DB.db.Employee.Find(IDEmployee);
            Title = "Редатирование сотрудника";
            BtnAddOrEditEmployee.Content = "Редактировать";
            Load();
        }

        public bool Check(Employee NewEmployee)
        {
            if (NewEmployee.LastName == string.Empty ||
                NewEmployee.Name == string.Empty ||
                NewEmployee.MiddleName == string.Empty ||
                NewEmployee.BirthDate == null ||
                NewEmployee.Position == null ||
                NewEmployee.Subdivision == null
                )
            {
                Helper.ErrorMessage("Не все значения введены");
                return false;
            }
            if (NewEmployee.LastName.All(char.IsLetter) == false ||
                NewEmployee.Name.All(char.IsLetter) == false ||
                (NewEmployee.MiddleName != string.Empty && NewEmployee.MiddleName.All(char.IsLetter) == false))
            {
                Helper.ErrorMessage("Не корректное ФИО");
                return false;
            }
            return true;
        }


        public bool AddEmployee(Employee NewEmployee)
        {
            if (Check(NewEmployee) == false)
            {
                return false;
            }
            DB.db.Employee.Add(NewEmployee);
            if (DB.Save() == false)
            {
                return false;
            }
            else
            {
                Helper.InformationMessage("Сотрудник добавлен");
                DataContext = new Employee();
                return true;
            }
        }


        public bool EditEmployee()
        {
            Employee CurrentEmployee = DataContext as Employee;
            if (Check(CurrentEmployee) == false)
            {
                return false;
            }
            if (DB.Save() == false)
            {
                return false;
            }
            Helper.InformationMessage("Сотрудник изменён");
            return true;
        }

        private void BtnAddOrEditEmployee_Click(object sender, RoutedEventArgs e)
        {
            Employee employee = DataContext as Employee;
            employee.IsWorking = true;
            if (employee.EmployeeID == 0)
            {
                AddEmployee(employee);
                return;
            }
            EditEmployee();
        }
    }
}
