﻿using System;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using SchoolProject;

namespace SchoolTest
{
    [TestClass]
    public class SchoolTest
    {
        [TestMethod]
        public void AddEmployeeTest()
        {
            App app = new App();
            app.InitializeComponent();
            Employee TestEmployee = new Employee
            {
                LastName = "",
                Name = "",
                MiddleName = "",
                BirthDate = DateTime.Today,
                Position = DB.db.Position.Find(1),
                Subdivision = DB.db.Subdivision.Find(1),
                IsWorking = true
            };
            WorkOfEmployeePage workOfEmployeePage = new WorkOfEmployeePage();
            Assert.IsFalse(workOfEmployeePage.AddEmployee(TestEmployee));
            TestEmployee.LastName = "Test";
            TestEmployee.Name = "Test2";
            TestEmployee.MiddleName = "Test";
            Assert.IsFalse(workOfEmployeePage.AddEmployee(TestEmployee));
            TestEmployee.Name = "Test";
            Assert.IsTrue(workOfEmployeePage.AddEmployee(TestEmployee));
            var FindEmploye = DB.db.Employee.FirstOrDefault(x => x.LastName == "Test");
            Assert.IsNotNull(FindEmploye);
            DB.db.Employee.Remove(FindEmploye);
            DB.Save();
        }


        [TestMethod]
        public void EditEmployeeTest()
        {
            var FirstEmployee = DB.db.Employee.Find(1);
            string NormalName = FirstEmployee.Name;
            FirstEmployee.Name = "";
            WorkOfEmployeePage workOfEmployeePage = new WorkOfEmployeePage();
            workOfEmployeePage.DataContext = FirstEmployee;
            Assert.IsFalse(workOfEmployeePage.EditEmployee());
            FirstEmployee.Name = "Test1";
            Assert.IsFalse(workOfEmployeePage.EditEmployee());
            FirstEmployee.Name = NormalName;
            Assert.IsTrue(workOfEmployeePage.EditEmployee());
        }

        [TestMethod]
        public void DeleteEmployeeTest()
        {
            Employee TestEmployee = new Employee
            {
                LastName = "Test",
                Name = "Test",
                MiddleName = "Test",
                BirthDate = DateTime.Today,
                IDPosition = 1,
                IDSubdivision = 1
            };
            DB.db.Employee.Add(TestEmployee);
            DB.Save();
            ShowEmployeePage showEmployeePage = new ShowEmployeePage();
            //Кнопка "Нет"
            Assert.IsFalse(showEmployeePage.DeleteEmployee(TestEmployee));
            //Кнопка "Да"
            Assert.IsTrue(showEmployeePage.DeleteEmployee(TestEmployee));
            var FindEmploye = DB.db.Employee.FirstOrDefault(x => x.LastName == "Test");
            Assert.IsNull(FindEmploye);

        }


        [TestMethod]
        public void LevenshteinDistanceTest()
        {
            Assert.AreEqual(Helper.LevenshteinDistance("мама", "папа"), 2);
            Assert.AreNotEqual(Helper.LevenshteinDistance("Пищаев", "Пинкаув"), 4);
        }
    }
}
